Bug 442158 - xcb severely cripples X11 performance
Summary: xcb severely cripples X11 performance
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: libX11
Version: 10
Hardware: All
OS: Linux
low
high
Target Milestone: ---
Assignee: Søren Sandmann Pedersen
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
: 433263 (view as bug list)
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2008-04-12 06:37 UTC by JW
Modified: 2014-06-18 09:10 UTC (History)
6 users (show)

Fixed In Version: 1.2-4.fc11
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2009-07-02 05:42:15 UTC


Attachments (Terms of Use)

Description JW 2008-04-12 06:37:49 UTC
Description of problem:
The xcb component of libX11 cripples x11 performance over network.

Version-Release number of selected component (if applicable):
libX11-1.1.3-4

How reproducible:
Always

Steps to Reproduce:
1. With a remote X11 server: xwd >test; xwud <test
2. Recompile libX11 with "configure --without-xcb" and install
3. Repeat 1.
  
Actual results:
With xcb performance is about 28 times worse than without.
Real times of 0.808 secs vs 0.028 secs over 1Gb network.

Expected results:
Xcb should not degrade performance so dramatically.


Additional info:
The libX11 rpm needs modification for build without xcb.

With xcb every write (in _XFlush) is followed by a read (_XEventsQueued) which
is the cause of the very poor performance. The read usually returns EAGAIN
because there is nothing to be read, but it is a severe performace hit anyhow. 
And why _XEvenetsQueued/read is being called when select/poll has previously
returned indicating only a single file descriptor was ready is anybody's guess.

Was xcb funded by MS?

I suggest that Fedora not include xcb in default distributions until xcb
demonstrates some tangible benefit, and not retrograde performance.

Comment 1 Torsten 2008-04-17 08:38:53 UTC
*** Bug 433263 has been marked as a duplicate of this bug. ***

Comment 2 Bug Zapper 2008-11-26 10:28:36 UTC
This message is a reminder that Fedora 8 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 8.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '8'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 8's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 8 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping

Comment 3 scientes-bugs+redhat-a1fff8cf024e022a6ab3 2009-05-26 22:46:39 UTC
upstream fix released:

https://bugs.freedesktop.org/show_bug.cgi?id=17868

Nagle's algorithm was mistakenly on.

Comment 4 Warren Togami 2009-06-24 17:16:15 UTC
http://kojipkgs.fedoraproject.org/packages/libxcb/1.1.91/7.fc10/
http://kojipkgs.fedoraproject.org/packages/libxcb/1.2/4.fc11/
Please test these builds.  I am not sure which side you need to upgrade, so upgrade both to be sure.

Comment 5 Jan Middelkoop 2009-06-25 14:16:28 UTC
Warren,

Before installing your RPM, typing 'ssh -Y localhost' in a terminal and then opening Firefox, produced a browser that was very slow.  Right-click menu took 3 seconds to appear.

I can confirm that your libxcb-1.2-4.fc11.x86_64.rpm solves this issue on Fedora 11 64-bit.  After installing the RPM the right-click menu appears instantly.

Thanks a bunch!

Comment 6 Fedora Update System 2009-06-29 20:45:14 UTC
libxcb-1.1.91-7.fc10 has been submitted as an update for Fedora 10.
http://admin.fedoraproject.org/updates/libxcb-1.1.91-7.fc10

Comment 7 Fedora Update System 2009-06-29 20:45:20 UTC
libxcb-1.2-4.fc11 has been submitted as an update for Fedora 11.
http://admin.fedoraproject.org/updates/libxcb-1.2-4.fc11

Comment 8 Fedora Update System 2009-07-02 05:42:09 UTC
libxcb-1.1.91-7.fc10 has been pushed to the Fedora 10 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 9 Fedora Update System 2009-07-02 05:50:02 UTC
libxcb-1.2-4.fc11 has been pushed to the Fedora 11 stable repository.  If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.